searchData={"items":[{"type":"module","title":"Outstand","doc":"Provides utilities to implement and work with `Outstanding` types","ref":"Outstand.html"},{"type":"macro","title":"Outstand.---/2","doc":"Infix shortcut --- for `Outstanding.outstanding/2`","ref":"Outstand.html#---/2"},{"type":"macro","title":"Examples - Outstand.---/2","doc":"```\niex> use Outstand\nOutstand\niex> 1 --- 1\nnil\niex> 1 --- :hello\n1\n```","ref":"Outstand.html#---/2-examples"},{"type":"macro","title":"Outstand.__using__/1","doc":"Enables infix `---`, `>>>` shortcuts, `defoutstanding`,\n`gen_nothing_outstanding_test`, `gen_something_outstanding_test` `gen_result_outstanding_test` macro","ref":"Outstand.html#__using__/1"},{"type":"macro","title":"Outstand.>>>/2","doc":"Infix shortcut >>> for `Outstanding.outstanding?/2`","ref":"Outstand.html#%3E%3E%3E/2"},{"type":"macro","title":"Examples - Outstand.>>>/2","doc":"```\niex> use Outstand\nOutstand\niex> 1 >>> 1\nfalse\niex> 1 >>> :hello\ntrue\n```","ref":"Outstand.html#%3E%3E%3E/2-examples"},{"type":"function","title":"Outstand.all_of/2","doc":"Function which expects all elements in expected list to be resolved by an element from actual list","ref":"Outstand.html#all_of/2"},{"type":"function","title":"Examples - Outstand.all_of/2","doc":"```\niex> Outstand.all_of([1, 2, 3], [3, 1, 2])\nnil\niex> Outstand.all_of([1, 2, 3], [1])\n:all_of\niex> Outstand.all_of([1, 2, 3], nil)\n:all_of\n```","ref":"Outstand.html#all_of/2-examples"},{"type":"function","title":"Outstand.any_atom/1","doc":"Function which expects any atom (nil is an atom)","ref":"Outstand.html#any_atom/1"},{"type":"function","title":"Examples - Outstand.any_atom/1","doc":"```\niex> Outstand.any_atom(:a)\nnil\niex> Outstand.any_atom(nil)\nnil\niex> Outstand.any_atom(\"a\")\n:any_atom\n```","ref":"Outstand.html#any_atom/1-examples"},{"type":"function","title":"Outstand.any_bitstring/1","doc":"Function which expects any bitstring","ref":"Outstand.html#any_bitstring/1"},{"type":"function","title":"Examples - Outstand.any_bitstring/1","doc":"```\niex> Outstand.any_bitstring(\"a\")\nnil\niex> Outstand.any_bitstring(:a)\n:any_bitstring\niex> Outstand.any_bitstring(nil)\n:any_bitstring\n```","ref":"Outstand.html#any_bitstring/1-examples"},{"type":"function","title":"Outstand.any_boolean/1","doc":"Function which expects any boolean","ref":"Outstand.html#any_boolean/1"},{"type":"function","title":"Examples - Outstand.any_boolean/1","doc":"```\niex> Outstand.any_boolean(true)\nnil\niex> Outstand.any_boolean(\"a\")\n:any_boolean\niex> Outstand.any_boolean(nil)\n:any_boolean\n```","ref":"Outstand.html#any_boolean/1-examples"},{"type":"function","title":"Outstand.any_date/1","doc":"Function which expects any date","ref":"Outstand.html#any_date/1"},{"type":"function","title":"Examples - Outstand.any_date/1","doc":"```\niex> Outstand.any_date(~D[2025-02-25])\nnil\niex> Outstand.any_date(\"2025-02-25\")\n:any_date\niex> Outstand.any_date(nil)\n:any_date\n```","ref":"Outstand.html#any_date/1-examples"},{"type":"function","title":"Outstand.any_date_time/1","doc":"Function which expects any date time","ref":"Outstand.html#any_date_time/1"},{"type":"function","title":"Examples - Outstand.any_date_time/1","doc":"```\niex> Outstand.any_date_time(~U[2025-02-25 11:59:00.00Z])\nnil\niex> Outstand.any_date_time(\"2025-02-25\")\n:any_date_time\niex> Outstand.any_date_time(nil)\n:any_date_time\n```","ref":"Outstand.html#any_date_time/1-examples"},{"type":"function","title":"Outstand.any_duration/1","doc":"Function which expects any duration","ref":"Outstand.html#any_duration/1"},{"type":"function","title":"Examples - Outstand.any_duration/1","doc":"```\niex> Outstand.any_duration(%Duration{month: 1})\nnil\niex> Outstand.any_duration(%{month: 1})\n:any_duration\niex> Outstand.any_duration(nil)\n:any_duration\n```","ref":"Outstand.html#any_duration/1-examples"},{"type":"function","title":"Outstand.any_float/1","doc":"Function which expects any float","ref":"Outstand.html#any_float/1"},{"type":"function","title":"Examples - Outstand.any_float/1","doc":"```\niex> Outstand.any_float(1.1)\nnil\niex> Outstand.any_float(1)\n:any_float\niex> Outstand.any_float(nil)\n:any_float\n```","ref":"Outstand.html#any_float/1-examples"},{"type":"function","title":"Outstand.any_integer/1","doc":"Function which expects any integer","ref":"Outstand.html#any_integer/1"},{"type":"function","title":"Examples - Outstand.any_integer/1","doc":"```\niex> Outstand.any_integer(1)\nnil\niex> Outstand.any_integer(1.1)\n:any_integer\niex> Outstand.any_integer(nil)\n:any_integer\n```","ref":"Outstand.html#any_integer/1-examples"},{"type":"function","title":"Outstand.any_list/1","doc":"Function which expects any list, including []","ref":"Outstand.html#any_list/1"},{"type":"function","title":"Examples - Outstand.any_list/1","doc":"```\niex> Outstand.any_list([:a])\nnil\niex> Outstand.any_list([])\nnil\niex> Outstand.any_list({:a, :b, :c})\n:any_list\niex> Outstand.any_list(nil)\n:any_list\n```","ref":"Outstand.html#any_list/1-examples"},{"type":"function","title":"Outstand.any_map/1","doc":"Function which expects any map","ref":"Outstand.html#any_map/1"},{"type":"function","title":"Examples - Outstand.any_map/1","doc":"```\niex> Outstand.any_map(%{a: :a})\nnil\niex> Outstand.any_map([:a])\n:any_map\niex> Outstand.any_map(nil)\n:any_map\n```","ref":"Outstand.html#any_map/1-examples"},{"type":"function","title":"Outstand.any_map_set/1","doc":"Function which expects any map set","ref":"Outstand.html#any_map_set/1"},{"type":"function","title":"Examples - Outstand.any_map_set/1","doc":"```\niex> Outstand.any_map_set(MapSet.new())\nnil\niex> Outstand.any_map_set(MapSet.new([:a]))\nnil\niex> Outstand.any_map_set([:a])\n:any_map_set\niex> Outstand.any_map_set(nil)\n:any_map_set\n```","ref":"Outstand.html#any_map_set/1-examples"},{"type":"function","title":"Outstand.any_naive_date_time/1","doc":"Function which expects any naive date time","ref":"Outstand.html#any_naive_date_time/1"},{"type":"function","title":"Examples - Outstand.any_naive_date_time/1","doc":"```\niex> Outstand.any_naive_date_time(~N[2025-02-25 11:59:00])\nnil\niex> Outstand.any_naive_date_time(\"2025-02-25\")\n:any_naive_date_time\niex> Outstand.any_naive_date_time(nil)\n:any_naive_date_time\n```","ref":"Outstand.html#any_naive_date_time/1-examples"},{"type":"function","title":"Outstand.any_number/1","doc":"Function which expects any number","ref":"Outstand.html#any_number/1"},{"type":"function","title":"Examples - Outstand.any_number/1","doc":"```\niex> Outstand.any_number(1)\nnil\niex> Outstand.any_number(1.1)\nnil\niex> Outstand.any_number(nil)\n:any_number\n```","ref":"Outstand.html#any_number/1-examples"},{"type":"function","title":"Outstand.any_of/2","doc":"Function which expects at least one element in expected list to be resolved by actual","ref":"Outstand.html#any_of/2"},{"type":"function","title":"Examples - Outstand.any_of/2","doc":"```\niex> Outstand.any_of([1, 2, 3], 1)\nnil\niex> Outstand.any_of([1, 2, 3], 0)\n:any_of\niex> Outstand.any_of([1, 2, 3], nil)\n:any_of\n```","ref":"Outstand.html#any_of/2-examples"},{"type":"function","title":"Outstand.any_of_actual_list/2","doc":"Function which expects at least one element from actual list to resolve expected","ref":"Outstand.html#any_of_actual_list/2"},{"type":"function","title":"Examples - Outstand.any_of_actual_list/2","doc":"```\niex> Outstand.any_of_actual_list(1, [1,2,3])\nnil\niex> Outstand.any_of_actual_list(1, [2, 3])\n1\niex> Outstand.any_of_actual_list(1, nil)\n1\n```","ref":"Outstand.html#any_of_actual_list/2-examples"},{"type":"function","title":"Outstand.any_range/1","doc":"Function which expects any range","ref":"Outstand.html#any_range/1"},{"type":"function","title":"Examples - Outstand.any_range/1","doc":"```\niex> Outstand.any_range(0..25//5)\nnil\niex> Outstand.any_range(5)\n:any_range\niex> Outstand.any_range(nil)\n:any_range\n```","ref":"Outstand.html#any_range/1-examples"},{"type":"function","title":"Outstand.any_time/1","doc":"Function which expects any naive date time","ref":"Outstand.html#any_time/1"},{"type":"function","title":"Examples - Outstand.any_time/1","doc":"```\niex> Outstand.any_time(~T[11:59:00.000])\nnil\niex> Outstand.any_time(\"11:59:00.000\")\n:any_time\niex> Outstand.any_time(nil)\n:any_time\n```","ref":"Outstand.html#any_time/1-examples"},{"type":"function","title":"Outstand.any_tuple/1","doc":"Function which expects any tuple","ref":"Outstand.html#any_tuple/1"},{"type":"function","title":"Examples - Outstand.any_tuple/1","doc":"```\niex> Outstand.any_tuple({:a, :b, :c})\nnil\niex> Outstand.any_tuple([:a])\n:any_tuple\niex> Outstand.any_tuple(nil)\n:any_tuple\n```","ref":"Outstand.html#any_tuple/1-examples"},{"type":"function","title":"Outstand.bounded_by/2","doc":"Function which expects actual to be bounded by the listed min and max values","ref":"Outstand.html#bounded_by/2"},{"type":"function","title":"Examples - Outstand.bounded_by/2","doc":"```\niex> Outstand.bounded_by([%Duration{hour: 1}, %Duration{minute: 90}], %Duration{minute: 70})\nnil\niex> Outstand.bounded_by([%Duration{hour: 1}, %Duration{minute: 90}], %Duration{minute: 50})\n:bounded_by\niex> Outstand.bounded_by([%Duration{hour: 1}, %Duration{minute: 90}], %Duration{hour: 2})\n:bounded_by\niex> Outstand.bounded_by([%Duration{hour: 1}, %Duration{minute: 90}], nil)\n:bounded_by\n```","ref":"Outstand.html#bounded_by/2-examples"},{"type":"function","title":"Outstand.current_date/1","doc":"Function which expects current date","ref":"Outstand.html#current_date/1"},{"type":"function","title":"Examples - Outstand.current_date/1","doc":"```\niex> today = DateTime.utc_now() |> DateTime.to_date()\niex> Outstand.current_date(today)\nnil\niex> Outstand.current_date(today |> Date.add(1))\n:current_date\niex> Outstand.current_date(today |> Date.add(-1))\n:current_date\niex> Outstand.current_date(nil)\n:current_date\n```","ref":"Outstand.html#current_date/1-examples"},{"type":"function","title":"Outstand.current_date_time/1","doc":"Function which expects current date time (+/- 1 min from now)","ref":"Outstand.html#current_date_time/1"},{"type":"function","title":"Examples - Outstand.current_date_time/1","doc":"```\niex> now = DateTime.utc_now()\niex> Outstand.current_date_time(now)\nnil\niex> Outstand.current_date_time(now |> DateTime.add(2, :minute))\n:current_date_time\niex> Outstand.current_date_time(now |> DateTime.add(-2, :minute))\n:current_date_time\niex> Outstand.current_date_time(nil)\n:current_date_time\n```","ref":"Outstand.html#current_date_time/1-examples"},{"type":"function","title":"Outstand.current_naive_date_time/1","doc":"Function which expects current naive date time (+/- 1 min from now)","ref":"Outstand.html#current_naive_date_time/1"},{"type":"function","title":"Examples - Outstand.current_naive_date_time/1","doc":"```\niex> now = DateTime.utc_now() |> DateTime.to_naive()\niex> Outstand.current_naive_date_time(now)\nnil\niex> Outstand.current_naive_date_time(now |> NaiveDateTime.add(2, :minute))\n:current_naive_date_time\niex> Outstand.current_naive_date_time(now |> NaiveDateTime.add(-2, :minute))\n:current_naive_date_time\niex> Outstand.current_naive_date_time(nil)\n:current_naive_date_time\n```","ref":"Outstand.html#current_naive_date_time/1-examples"},{"type":"function","title":"Outstand.current_time/1","doc":"Function which expects current time (+/- 1 min from now)","ref":"Outstand.html#current_time/1"},{"type":"function","title":"Examples - Outstand.current_time/1","doc":"```\niex> now = DateTime.utc_now() |> DateTime.to_time()\niex> Outstand.current_time(now)\nnil\niex> Outstand.current_time(now |> Time.add(2, :minute))\n:current_time\niex> Outstand.current_time(now |> Time.add(-2, :minute))\n:current_time\niex> Outstand.current_time(nil)\n:current_time\n```","ref":"Outstand.html#current_time/1-examples"},{"type":"macro","title":"Outstand.defoutstanding/3","doc":"Helper to define whether the expected side (expected) is realised by actual side (actual), returns nil if so,\notherwise return what is not realised (outstanding)\naccepts two `term :: type` pairs\nand block of code where relation is described.","ref":"Outstand.html#defoutstanding/3"},{"type":"macro","title":"Examples - Outstand.defoutstanding/3","doc":"```\niex> quote do\n...>   use Outstand\n...>   defmodule Foo do\n...>     defstruct [:value, :meta]\n...>   end\n...>   defmodule Bar do\n...>     defstruct [:value, :meta]\n...>   end\n...>   defoutstanding expected :: Foo, actual :: Any do\n...>     case Outstand.type_of(actual) do\n...>       Foo -> Outstanding.outstanding(expected.value, actual.value)\n...>       Bar -> Outstanding.outstanding(expected.value, actual.value)\n...>       Integer -> Outstanding.outstanding(expected.value, actual)\n...>       _ -> expected\n...>     end\n...>   end\n...> end\n...> |> Code.compile_quoted\niex> quote do\n...>   expected = %Foo{value: 1, meta: 1}\n...>   actual = %Foo{value: 1, meta: 2}\n...>   Outstanding.outstanding(expected, actual)\n...> end\n...> |> Code.eval_quoted\n...> |> elem(0)\nnil\niex> quote do\n...>   expected = %Foo{value: 1, meta: 1}\n...>   actual = %Bar{value: 1, meta: 2}\n...>   Outstanding.outstanding(expected, actual)\n...> end\n...> |> Code.eval_quoted\n...> |> elem(0)\nnil\niex> quote do\n...>   expected = %Foo{value: 1, meta: 1}\n...>   actual = 1\n...>   Outstanding.outstanding(expected, actual)\n...> end\n...> |> Code.eval_quoted\n...> |> elem(0)\nnil\n```","ref":"Outstand.html#defoutstanding/3-examples"},{"type":"function","title":"Outstand.empty_list/1","doc":"Function which expects empty list","ref":"Outstand.html#empty_list/1"},{"type":"function","title":"Examples - Outstand.empty_list/1","doc":"```\niex> Outstand.empty_list([])\nnil\niex> Outstand.empty_list([:a])\n:empty_list\niex> Outstand.empty_list(nil)\n:empty_list\n```","ref":"Outstand.html#empty_list/1-examples"},{"type":"function","title":"Outstand.empty_map/1","doc":"Function which expects empty map","ref":"Outstand.html#empty_map/1"},{"type":"function","title":"Examples - Outstand.empty_map/1","doc":"```\niex> Outstand.empty_map(%{})\nnil\niex> Outstand.empty_map(%{a: :a})\n:empty_map\niex> Outstand.empty_map(nil)\n:empty_map\n```","ref":"Outstand.html#empty_map/1-examples"},{"type":"function","title":"Outstand.empty_map_set/1","doc":"Function which expects empty map set","ref":"Outstand.html#empty_map_set/1"},{"type":"function","title":"Examples - Outstand.empty_map_set/1","doc":"```\niex> Outstand.empty_map_set(MapSet.new())\nnil\niex> Outstand.empty_map_set(MapSet.new([:a]))\n:empty_map_set\niex> Outstand.empty_map_set(nil)\n:empty_map_set\n```","ref":"Outstand.html#empty_map_set/1-examples"},{"type":"function","title":"Outstand.explicit_nil/1","doc":"Function which expects explicit nil","ref":"Outstand.html#explicit_nil/1"},{"type":"function","title":"Examples - Outstand.explicit_nil/1","doc":"```\niex> Outstand.explicit_nil(:explicit_nil)\nnil\niex> Outstand.explicit_nil(nil)\n:explicit_nil\niex> Outstand.explicit_nil(:a)\n:explicit_nil\n```","ref":"Outstand.html#explicit_nil/1-examples"},{"type":"function","title":"Outstand.future_date/1","doc":"Function which expects future date","ref":"Outstand.html#future_date/1"},{"type":"function","title":"Examples - Outstand.future_date/1","doc":"```\niex> today = DateTime.utc_now() |> DateTime.to_date()\niex> Outstand.future_date(today |> Date.add(1))\nnil\niex> Outstand.future_date(today)\n:future_date\niex> Outstand.future_date(nil)\n:future_date\n```","ref":"Outstand.html#future_date/1-examples"},{"type":"function","title":"Outstand.future_date_time/1","doc":"Function which expects future date time","ref":"Outstand.html#future_date_time/1"},{"type":"function","title":"Examples - Outstand.future_date_time/1","doc":"```\niex> now = DateTime.utc_now()\niex> Outstand.future_date_time(now |> DateTime.add(1, :minute))\nnil\niex> Outstand.future_date_time(now)\n:future_date_time\niex> Outstand.future_date_time(nil)\n:future_date_time\n```","ref":"Outstand.html#future_date_time/1-examples"},{"type":"function","title":"Outstand.future_naive_date_time/1","doc":"Function which expects future naive date time","ref":"Outstand.html#future_naive_date_time/1"},{"type":"function","title":"Examples - Outstand.future_naive_date_time/1","doc":"```\niex> now = DateTime.utc_now() |> DateTime.to_naive()\niex> Outstand.future_naive_date_time(now |> NaiveDateTime.add(1, :minute))\nnil\niex> Outstand.future_naive_date_time(now)\n:future_naive_date_time\niex> Outstand.future_naive_date_time(nil)\n:future_naive_date_time\n```","ref":"Outstand.html#future_naive_date_time/1-examples"},{"type":"function","title":"Outstand.future_time/1","doc":"Function which expects future time","ref":"Outstand.html#future_time/1"},{"type":"function","title":"Examples - Outstand.future_time/1","doc":"```\niex> now = DateTime.utc_now() |> DateTime.to_time()\niex> Outstand.future_time(now |> Time.add(1, :minute))\nnil\niex> Outstand.future_time(now)\n:future_time\niex> Outstand.future_time(nil)\n:future_time\n```","ref":"Outstand.html#future_time/1-examples"},{"type":"macro","title":"Outstand.gen_nothing_outstanding_test/3","doc":"","ref":"Outstand.html#gen_nothing_outstanding_test/3"},{"type":"macro","title":"Outstand.gen_result_outstanding_test/4","doc":"","ref":"Outstand.html#gen_result_outstanding_test/4"},{"type":"macro","title":"Outstand.gen_something_outstanding_test/3","doc":"","ref":"Outstand.html#gen_something_outstanding_test/3"},{"type":"function","title":"Outstand.greater_than/2","doc":"Function which expects actual to be greater than the value","ref":"Outstand.html#greater_than/2"},{"type":"function","title":"Examples - Outstand.greater_than/2","doc":"```\niex> Outstand.greater_than(%Duration{hour: 1}, %Duration{hour: 2})\nnil\niex> Outstand.greater_than(%Duration{hour: 1}, %Duration{hour: 1})\n:greater_than\niex> Outstand.greater_than(%Duration{hour: 1}, nil)\n:greater_than\n```","ref":"Outstand.html#greater_than/2-examples"},{"type":"function","title":"Outstand.less_than/2","doc":"Function which expects actual to be less than the value","ref":"Outstand.html#less_than/2"},{"type":"function","title":"Examples - Outstand.less_than/2","doc":"```\niex> Outstand.less_than(%Duration{hour: 2}, %Duration{hour: 1})\nnil\niex> Outstand.less_than(%Duration{hour: 1}, %Duration{hour: 1})\n:less_than\niex> Outstand.less_than(%Duration{hour: 1}, nil)\n:less_than\n```","ref":"Outstand.html#less_than/2-examples"},{"type":"function","title":"Outstand.map_to_struct/2","doc":"Converts term to struct if a map","ref":"Outstand.html#map_to_struct/2"},{"type":"function","title":"Examples - Outstand.map_to_struct/2","doc":"```\niex> today = DateTime.utc_now() |> DateTime.to_date()\niex> today_map = Map.delete(today, :__struct__)\niex> assert today == Outstand.map_to_struct(today_map, Date)\niex> Outstand.map_to_struct(nil, Date)\nnil\n```","ref":"Outstand.html#map_to_struct/2-examples"},{"type":"function","title":"Outstand.nil_outstanding?/1","doc":"Checks whether a result has nothing outstanding","ref":"Outstand.html#nil_outstanding?/1"},{"type":"function","title":"Examples - Outstand.nil_outstanding?/1","doc":"```\niex> Outstand.nil_outstanding?(1)\nfalse\niex> Outstand.nil_outstanding?(nil)\ntrue\niex> Outstand.nil_outstanding?(%{})\nfalse\niex> Outstand.nil_outstanding?([])\nfalse\n```","ref":"Outstand.html#nil_outstanding?/1-examples"},{"type":"function","title":"Outstand.nil_outstanding?/2","doc":"Is nothing outstanding given expected and actual term?","ref":"Outstand.html#nil_outstanding?/2"},{"type":"function","title":"Examples - Outstand.nil_outstanding?/2","doc":"```\niex> Outstand.nil_outstanding?(1, 1)\ntrue\niex> Outstand.nil_outstanding?(1, nil)\nfalse\niex> Outstand.nil_outstanding?(1, 2)\nfalse\n```","ref":"Outstand.html#nil_outstanding?/2-examples"},{"type":"function","title":"Outstand.non_empty_keyword/1","doc":"Function which expects non empty keyword","ref":"Outstand.html#non_empty_keyword/1"},{"type":"function","title":"Examples - Outstand.non_empty_keyword/1","doc":"```\niex> Outstand.non_empty_keyword([a: :a])\nnil\niex> Outstand.non_empty_keyword([])\n:non_empty_keyword\niex> Outstand.non_empty_keyword(nil)\n:non_empty_keyword\n```","ref":"Outstand.html#non_empty_keyword/1-examples"},{"type":"function","title":"Outstand.non_empty_list/1","doc":"Function which expects non empty list","ref":"Outstand.html#non_empty_list/1"},{"type":"function","title":"Examples - Outstand.non_empty_list/1","doc":"```\niex> Outstand.non_empty_list([:a])\nnil\niex> Outstand.non_empty_list([])\n:non_empty_list\niex> Outstand.non_empty_list(nil)\n:non_empty_list\n```","ref":"Outstand.html#non_empty_list/1-examples"},{"type":"function","title":"Outstand.non_empty_map/1","doc":"Function which expects non empty map","ref":"Outstand.html#non_empty_map/1"},{"type":"function","title":"Examples - Outstand.non_empty_map/1","doc":"```\niex> Outstand.non_empty_map(%{a: :a})\nnil\niex> Outstand.non_empty_map(%{})\n:non_empty_map\niex> Outstand.non_empty_map(nil)\n:non_empty_map\n```","ref":"Outstand.html#non_empty_map/1-examples"},{"type":"function","title":"Outstand.non_empty_map_set/1","doc":"Function which expects non empty map set","ref":"Outstand.html#non_empty_map_set/1"},{"type":"function","title":"Examples - Outstand.non_empty_map_set/1","doc":"```\niex> Outstand.non_empty_map_set(MapSet.new([:a]))\nnil\niex> Outstand.non_empty_map_set(MapSet.new())\n:non_empty_map_set\niex> Outstand.non_empty_map_set(nil)\n:non_empty_map_set\n```","ref":"Outstand.html#non_empty_map_set/1-examples"},{"type":"function","title":"Outstand.non_nil_atom/1","doc":"Function which expects any not nil atom","ref":"Outstand.html#non_nil_atom/1"},{"type":"function","title":"Examples - Outstand.non_nil_atom/1","doc":"```\niex> Outstand.non_nil_atom(:a)\nnil\niex> Outstand.non_nil_atom(nil)\n:non_nil_atom\niex> Outstand.non_nil_atom(\"a\")\n:non_nil_atom\n```","ref":"Outstand.html#non_nil_atom/1-examples"},{"type":"function","title":"Outstand.none_of/2","doc":"Function which expects no element in expected list to be resolved by actual","ref":"Outstand.html#none_of/2"},{"type":"function","title":"Examples - Outstand.none_of/2","doc":"```\niex> Outstand.none_of([1, 2, 3], 0)\nnil\niex> Outstand.none_of([1, 2, 3], 1)\n:none_of\niex> Outstand.none_of([1, 2, 3], nil)\nnil\n```","ref":"Outstand.html#none_of/2-examples"},{"type":"function","title":"Outstand.one_of/2","doc":"Function which expects exactly one element in expected list to be resolved by actual","ref":"Outstand.html#one_of/2"},{"type":"function","title":"Examples - Outstand.one_of/2","doc":"```\niex> Outstand.one_of([1, 2, 3], 1)\nnil\niex> Outstand.one_of([1, 1, 3], 1)\n:one_of\niex> Outstand.one_of([1, 2, 3], nil)\n:one_of\n```","ref":"Outstand.html#one_of/2-examples"},{"type":"function","title":"Outstand.outstanding?/1","doc":"Checks whether a result has anything outstanding","ref":"Outstand.html#outstanding?/1"},{"type":"function","title":"Examples - Outstand.outstanding?/1","doc":"```\niex> Outstand.outstanding?(1)\ntrue\niex> Outstand.outstanding?(nil)\nfalse\niex> Outstand.outstanding?(%{})\ntrue\niex> Outstand.outstanding?([])\ntrue\n```","ref":"Outstand.html#outstanding?/1-examples"},{"type":"function","title":"Outstand.past_date/1","doc":"Function which expects past date","ref":"Outstand.html#past_date/1"},{"type":"function","title":"Examples - Outstand.past_date/1","doc":"```\niex> Outstand.past_date(~D[2002-02-25])\nnil\niex> Outstand.past_date(~D[2102-02-25])\n:past_date\niex> Outstand.past_date(nil)\n:past_date\n```","ref":"Outstand.html#past_date/1-examples"},{"type":"function","title":"Outstand.past_date_time/1","doc":"Function which expects past date time","ref":"Outstand.html#past_date_time/1"},{"type":"function","title":"Examples - Outstand.past_date_time/1","doc":"```\niex> Outstand.past_date_time(~U[2002-02-25 11:59:00.00Z])\nnil\niex> Outstand.past_date_time(~U[2102-02-25 11:59:00.00Z])\n:past_date_time\niex> Outstand.past_date_time(nil)\n:past_date_time\n```","ref":"Outstand.html#past_date_time/1-examples"},{"type":"function","title":"Outstand.past_naive_date_time/1","doc":"Function which expects past naive date time","ref":"Outstand.html#past_naive_date_time/1"},{"type":"function","title":"Examples - Outstand.past_naive_date_time/1","doc":"```\niex> Outstand.past_naive_date_time(~N[2002-02-25 11:59:00])\nnil\niex> Outstand.past_naive_date_time(~N[2102-02-25 11:59:00])\n:past_naive_date_time\niex> Outstand.past_naive_date_time(nil)\n:past_naive_date_time\n```","ref":"Outstand.html#past_naive_date_time/1-examples"},{"type":"function","title":"Outstand.past_time/1","doc":"Function which expects past time","ref":"Outstand.html#past_time/1"},{"type":"function","title":"Examples - Outstand.past_time/1","doc":"```\niex> Outstand.past_time(~T[00:00:00.000])\nnil\niex> Outstand.past_time(~T[23:59:59.999])\n:past_time\niex> Outstand.past_time(nil)\n:past_time\n```","ref":"Outstand.html#past_time/1-examples"},{"type":"function","title":"Outstand.suppress/1","doc":"Suppress outstanding result when list of nils, empty list, map, map set or tuple","ref":"Outstand.html#suppress/1"},{"type":"function","title":"Examples - Outstand.suppress/1","doc":"```\niex> Outstand.suppress([nil, nil])\nnil\niex> Outstand.suppress([])\nnil\niex> Outstand.suppress([:a])\n[:a]\niex> Outstand.suppress(%{})\nnil\niex> Outstand.suppress(%{x: :a})\n%{x: :a}\niex> Outstand.suppress(MapSet.new())\nnil\niex> Outstand.suppress(MapSet.new([:a]))\nMapSet.new([:a])\niex> Outstand.suppress({})\nnil\niex> Outstand.suppress({:a})\n{:a}\n```","ref":"Outstand.html#suppress/1-examples"},{"type":"function","title":"Outstand.type_of/1","doc":"Types the argument, similar to Typable","ref":"Outstand.html#type_of/1"},{"type":"function","title":"Examples - Outstand.type_of/1","doc":"```\niex> Outstand.type_of(nil)\nAtom\niex> Outstand.type_of(:a)\nAtom\niex> Outstand.type_of(true)\nBoolean\niex> Outstand.type_of(\"a\")\nBitString\niex> Outstand.type_of(1.1)\nFloat\niex> Outstand.type_of(&Outstand.any_atom/1)\nFunction\niex> Outstand.type_of(1)\nInteger\niex> Outstand.type_of([:a])\nList\niex> Outstand.type_of([a: %{a: \"a\", b: \"b\"}])\nList\niex> Outstand.type_of(%{a: :a})\nMap\niex> Outstand.type_of(MapSet.new([:a]))\nMapSet\niex> Outstand.type_of(0..25//5)\nRange\niex> Outstand.type_of({:a, :b, :c})\nTuple\niex> Outstand.type_of({:a, %{a: \"a\", b: \"b\"}})\nTuple\niex> Outstand.type_of(~U[2025-02-25 11:59:00.00Z])\nDateTime\niex> Outstand.type_of(~D[2025-02-25])\nDate\niex> Outstand.type_of(self())\nOther\n```","ref":"Outstand.html#type_of/1-examples"},{"type":"function","title":"Outstand.unbounded_by/2","doc":"Function which expects actual not to be bounded by the listed min and max values","ref":"Outstand.html#unbounded_by/2"},{"type":"function","title":"Examples - Outstand.unbounded_by/2","doc":"```\niex> Outstand.unbounded_by([%Duration{hour: 1}, %Duration{minute: 90}], %Duration{minute: 30})\nnil\niex> Outstand.unbounded_by([%Duration{hour: 1}, %Duration{minute: 90}], %Duration{hour: 2})\nnil\niex> Outstand.unbounded_by([%Duration{hour: 1}, %Duration{minute: 90}], %Duration{minute: 70})\n:unbounded_by\niex> Outstand.unbounded_by([%Duration{hour: 1}, %Duration{minute: 90}], nil)\n:unbounded_by\n```","ref":"Outstand.html#unbounded_by/2-examples"},{"type":"protocol","title":"Outstanding","doc":"Protocol for comparing expected and actual, highlighting outstanding expectations unmet by actual","ref":"Outstanding.html"},{"type":"function","title":"Outstanding.outstanding/2","doc":"Outstanding of expected realised by actual, returns nil or outstanding","ref":"Outstanding.html#outstanding/2"},{"type":"function","title":"Outstanding.outstanding?/2","doc":"Is anything outstanding?","ref":"Outstanding.html#outstanding?/2"},{"type":"type","title":"Outstanding.result/0","doc":"","ref":"Outstanding.html#t:result/0"},{"type":"type","title":"Outstanding.t/0","doc":"","ref":"Outstanding.html#t:t/0"},{"type":"extras","title":"Guide","doc":"# Outstanding\n\nOutstanding: something not yet dealt with.\n\nThe outstanding protocol is for those times when you want to know if any or which expectations have not been sufficiently met, and equality doesn't actually do it for you.\n\nWe have two terms, `expected` and  `actual`, apply `outstanding(expected, actual)` and see if nothing is outstanding `nil`, or we get back what is `outstanding` for us to work on.\n\nOutstanding implementations are provided for most types, as well as helper functions to make it easy to add implementations for your structs. Outstanding implementations which accept expected Functions are provided, providing a point of extensibility. Convenience expected functions are also provided.\n\n```elixir\niex> import Outstanding\niex> outstanding(%{x: :a, y: :b}, %{})\n%{y: :b, x: :a}\niex> outstanding(%{x: :a, y: :b}, %{y: :b})\n%{x: :a}\niex> outstanding(%{x: :a, y: :b}, %{x: :a, y: :b})\nnil\niex> outstanding(%{x: :a, y: :b}, %{x: :a, y: :b, z: :c})\nnil\n```","ref":"readme.html"},{"type":"extras","title":"Installation - Guide","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `outstanding` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:outstanding, \"~> 0.3.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Tutorial - Guide","doc":"To get started you need a running instance of [Livebook](https://livebook.dev/)\n\n[![Run in Livebook](https://livebook.dev/badge/v1/blue.svg)](https://livebook.dev/run?url=https%3A%2F%2Fgithub.com%2Fdiffo%2Ddev%2Foutstanding%2Fblob%2Fdev%2Foutstanding.livemd)","ref":"readme.html#tutorial"},{"type":"extras","title":"Outstanding? - Guide","doc":"Outstanding.outstanding? simply calls Outstanding.outstanding, and is true if anything is outstanding, or false if nil outstanding.\n\n```elixir\niex> import Outstanding\niex> outstanding?(%{x: :a, y: :b}, %{y: :b})\ntrue\niex> outstanding?(%{x: :a, y: :b}, %{x: :a, y: :b})\nfalse\n```","ref":"readme.html#outstanding"},{"type":"extras","title":"Supported Types - Guide","doc":"Out of the box we have outstanding protocol implementations for the following types:\n\n| Elixir Type Module | Type Example               | Notes               | Resolving Types              | Related Expected Functions                                            |\n|--------------------|----------------------------|---------------------|------------------------------|-----------------------------------------------------------------------|\n| Atom               | :a                         | nil is an Atom      | Atom                         | any_atom, non_nil_atom                                                |\n| BitString          | \"a\"                        |                     | BitString                    | any_bitstring                                                         |\n| Boolean            | true                       |                     | Boolean                      | any_boolean                                                           |\n| Date               | ~D[2025-02-25]             |                     | Date                         | any_date, current_date, future_date, past_date                        |\n| DateTime           | U[2025-02-25 11:59:00.00Z] |                     | DateTime                     | any_date_time, current_date_time, future_date_time, past_date_time    |\n| Duration           | %Duration{minute: 60}      |                     | Duration                     | any_duration                                                          |\n| Float              | 1.1                        |                     | Float, Integer               | any_float, any_number                                                 |\n| Function           | &Outstand.non_nil_atom/1   | actual is argument  | Any                          | -                                                                     |\n| Integer            | 1                          |                     | Integer, Float, Range        | any_integer, any_number                                               |\n| Keyword            | [a: :a]                    | handled by List     | (Keyword) List               | non_empty_keyword                                                     |\n| List               | [:a]                       |                     | List                         | any_list, empty_list, non_empty_list                                  |\n| MapSet             | MapSet.new([:a])           | uses difference     | MapSet                       | any_map_set, empty_map_set, non_empty_map_set                         |\n| Map                | {a: :b, c: :d}             | strict              | Map                          | any_map, empty_map, non_empty_map                                     |\n| NaiveDateTime      | ~N[2025-02-25 11:59:00]    |                     | NaiveDateTime                | any_naive_date_time, future_time, current_time, past_time             |\n| Range              | 1                          |                     | Range, Integer               | any_range                                                             |\n| Regex              | ~r/foo/                    | actual is argument  | String.Chars implementations | -                                                                     |\n| Time               | ~T[11:59:00.000]           |                     | Time                         | any_time, current_time, future_time, past_time                        |\n| Tuple              | {a: :b}                    | handled by Any      | Tuple                        | any_tuple                                                             |\n\nMaps call outstanding on each element is expected, but allow extra elements in actual.\n\nKeywords are Lists of Tuples but are handled like Maps.\n\nLists (other than Keywords) are strict in that they must be in order, so lists must have the same number of elements for outstanding to be nil. Outstanding is attempted on each pair of expected/actual elements, even when they have unequal number, in order to return a list of resolved (nil) or outstanding elements. If all expected elements are resolved however there are extra actual elements a list of nils is returned, of length expected.\n\nMapSets are not strict in that actual may contain additional elements, however MapSet.difference is used on the elements (which uses equals not outstanding).\n\nTuples not part of Keywork List are matched using Any, which uses equals.\n\nDate, Time, DateTime and NaiveDateTime are supported, where Expected Function current_date matches today's date, other current times are now +/- 1 min.\n\nFunction must be an outstanding function which takes a single argument actual, such as the expected functions.\n\nRegex can be any regex operating on the actual BitString, uses Regex.match?\n\nOf course you can easily implement the outstanding protocol for your own type (especially structs) using the defoutstanding macro.","ref":"readme.html#supported-types"},{"type":"extras","title":"Expected Functions - Guide","doc":"Sometimes our expectation is a bit vague, for instance in the example above we initially did not know the id. We can supply a function as an expectation, when not met this supplies a corresponding atom.\n\nAn expected function of arity 1 implicitly has actual as the argument.\n\n```elixir\niex> import Outstanding\nOutstanding\niex> use Outstand\nOutstand\n\niex> outstanding(&Outstand.any_integer/1, 546)\nnil\niex> outstanding(&Outstand.any_integer/1, nil)\n:any_integer\n\n```\n\n&Outstand.any_integer/1 is one of many convenience functions in Outstand.\n```elixir\n  @spec any_integer(any()) :: :any_integer | nil\n  def any_integer(actual) do\n    if is_integer(actual) do\n      nil\n    else\n      :any_integer\n    end\n  end\n```\n\nThere are are number of included expected functions, see the table in Supported Types for the types they relate to.\n\nExpected functions of arity 2 are also supported. These have the form of a tuple of function and term, where term is an argument or argument list.\n\n| Expected Function | Expected Type           | Resolving Types         | Behaviour                                                                             |\n|-------------------|-------------------------|-------------------------|---------------------------------------------------------------------------------------|\n| all_of            | List, Map, Keyword List | List, Map, Keyword List | expects all expected elements to be resolved by any actual element                    |\n| any_of            | List, Map, Keyword List | Any                     | expects at least one expected element to be resolved by actual                        |\n| none_of           | List, Map, Keyword List | List, Map, Keyword List | expects no expected elements to be resolved by any actual element                     |\n| one_of            | List, Map, Keyword List | List, Map, Keyword List | expects exactly one expected element to be resolved by any actual element             |\n| less_than         | Duration                | Duration                | expects actual to be less than value                                                  |\n| greater_than      | Duration                | Duration                | expects actual to be greater than value                                               |\n| bounded_by        | Duration                | Duration                | expects actual to be bounded by [min_value, max_value]                                |\n| unbounded_by      | Duration                | Duration                | expects actual to be not bounded by [min_value, max_value]                            |\n\nYou can supply your own functions where needed.","ref":"readme.html#expected-functions"},{"type":"extras","title":"Exceeds and Difference Operators - Guide","doc":"For convenient use in expressions we've implemented operators.\n\nThe 'exceeds' operator tells us whether our expectations exceed our actual. ```expected >>> actual``` is equivalent to ```Outstanding.outstanding?(expected, actual)```\n\nThe 'difference' operator tells us what expectations remain unmet. ```expected --- actual``` is equivalent to ```Outstanding.outstanding(expected, actual)```\n\nExample of infix shortcuts usage:\n\n```elixir\niex> use Outstand\nOutstand\n\niex> [:a, :b] --- [:a, :b]\nnil\niex> [:a, :b] >>> [:a, :b]\nfalse\niex> %{x: :a, y: :b} >>> %{y: :b}\ntrue\niex> %{x: :a, y: :b} --- %{y: :b}\n%{x: :a}\n```","ref":"readme.html#exceeds-and-difference-operators"},{"type":"extras","title":"Expecting Anything or Nothing - Guide","doc":"We've taken a nil expectation to mean that we have no expectations, so are satisified by actual anything.\n\nHowever we often need to expect actual nothing, say we managed something that shouldn't exist now, and we want to check for this.\nWe have two alternatives for this. In the first we can expect :explicit_nil which is only satisfied with :explicit_nil:\n\n```elixir\niex> Outstanding.outstanding(:explicit_nil, :explicit_nil)\nnil\niex> Outstanding.outstanding(:explicit_nil, \"a\")\n:explicit_nil\niex> Outstanding.outstanding(:explicit_nil, nil)\n:explicit_nil\n```\nThere is a helper function &Outstand.explicit_nil/1, but it behaves identically. The disadvantage here is that actual needs to be coded with :explicit_nil, rather than nil or simply missing keys, which requires transformation of actual ahead of differencing with outstanding.\n\nAnother alternative is the :no_value atom, which is only used as an expected value, where the expectation is a key-value, such as a Map or Keyword List element. It expects that there is no value, either due to there being no key, or the key having a value of nil. This can be very useful as we can avoid an actual transformation. The no_value expectation can be resolved by actual :no_value or nil.\n\n```elixir\niex> Outstanding.outstanding(%{a: :no_value}, %{})\nnil\niex> Outstanding.outstanding(%{a: :no_value}, %{a: nil})\nnil\niex> Outstanding.outstanding(%{a: :no_value}, %{a: \"a\"})\n%{a: :no_value}\niex> Outstanding.outstanding([a: :no_value], [])\nnil\niex> Outstanding.outstanding([a: :no_value], [a: nil])\nnil\niex> Outstanding.outstanding([a: :no_value], [a: \"a\"])\n[a: :no_value]\niex> Outstanding.outstanding(:no_value, :no_value)\nnil\niex> Outstanding.outstanding(:no_value, nil)\nnil\niex> Outstanding.outstanding(:no_value, \"a\")\n:no_value\n```","ref":"readme.html#expecting-anything-or-nothing"},{"type":"extras","title":"Implementing Outstanding for other types - Guide","doc":"The defoutstanding macro can be used to implement outstanding on other types, including your own structs.\n\nThis requires some though as to what it means to 'resolve' your expected struct with actual. The following XYZ struct uses Outstanding on the map to resolve :x, :y, :z, and also expects that actual is also an XYZ struct, although you may want to allow matching using straight maps or other struct with equivalent fields.\n\n```elixir\nuse Outstand\n\ndefmodule XYZ do\n  defstruct [:x, :y, :z]\nend\n\ndefoutstanding expected :: XYZ, actual :: Any do\n  case {expected, actual} do\n    {nil, nil} ->\n      nil\n    {_, ^expected} ->\n      nil\n    {%name{}, %name{}} ->\n      expected\n      |> Map.from_struct()\n      |> Outstanding.outstanding(Map.from_struct(actual))\n      |> Outstand.map_to_struct(name)\n    {_, _} ->\n      # not an exact match so default to outstanding\n      expected\n  end\nend\n```\n\nIf you are using Ash, then consider using the [ash_outstanding](https://github.com/diffo-dev/ash_outstanding) extension which enables you to implement Outstanding protocol on your Ash Resources with a simple DSL.","ref":"readme.html#implementing-outstanding-for-other-types"},{"type":"extras","title":"Testing - Guide","doc":"`use Outstand` expression also provides 3 utilities which can auto-generate ExUnit tests for implementation of `Outstanding` protocol for your types:\n\n```elixir\niex>use Outstand\n\niex> gen_something_outstanding_test(\"value outstanding\", \"a\", \"b\")\niex> gen_nothing_outstanding_test(\"realized\", \"a\", \"a\")\niex> gen_result_outstanding_test(\"value result\", \"a\", \"b\", \"a\")\n```","ref":"readme.html#testing"},{"type":"extras","title":"Example - Guide","doc":"We often have minimum expectations that must be met, which when not met by actuality are `outstanding`. However we may also be happy for these expectations to be exceeded.\n\nWe may expect something to exist, but we may not know its identifier yet. If we have a list of managed child services, and imagine a scenario where while our backup feature is enabled, we should have a backup child service, however before we acquire it we won't know its identity.\n\n| scenario                          | expected                                 | actual                                         | outstanding? | outstanding                     |\n|-----------------------------------|------------------------------------------|------------------------------------------------|--------------|---------------------------------|\n| no backup                         | []                                       | []                                             | false        | nil                             |\n| enable backup - commmenced        | [%{alias: :backup, state: :ok}]          | []                                             | true         | [%{alias: :backup, state: :ok}] |\n| enable backup - backup created    | [%{alias: :backup, state: :ok}]          | [%{alias: :backup, id: 453, state: :starting}] | true         | [%{alias: :backup, state: :ok}] |\n| enable backup - backup bound      | [%{alias: :backup, id: 453, state: :ok}] | [%{alias: :backup, id: 453, state: :ok}]       | false        | nil                             |\n \nOnce we've created a backup child we want to keep track of it, so we refine the expectation to include it's specific id. We also monitor its behaviour and apply corrective action, just like a real child.\n\nAn application using outstanding would update expected, then do work based on what is outstanding given actual.Outstanding can be further processed (by your code) to detemine next action based on your priority of goals not met, constraints, business rules, etc.","ref":"readme.html#example"},{"type":"extras","title":"Acknowledgements - Guide","doc":"Thanks to Ilja Tkachuk for [comparable](https://github.com/coingaming/comparable) which was an exemplar.\n\nKudos to the [Elixir Core Team](https://elixir-lang.org/) for [elixir](https://github.com/elixir-lang/elixir) 🚀","ref":"readme.html#acknowledgements"},{"type":"extras","title":"Links - Guide","doc":"[Diffo.dev](https://www.diffo.dev)\n\n[ash_outstanding](https://github.com/diffo-dev/ash_outstanding)\n\n[documentation]( )","ref":"readme.html#links"},{"type":"extras","title":"License","doc":"MIT License\n\nCopyright (c) 2025 Matthew Graham Beanland\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.1"}}